use crate::ems::emu::BroadcastMessage;
use tokio::join;

pub mod bms;
pub mod emu;
pub mod pcs;
pub mod tms;

pub type Producer = tokio::sync::mpsc::Sender<String>;
pub type Consumer = tokio::sync::broadcast::Receiver<BroadcastMessage>;
#[async_trait::async_trait]
pub trait Service: Send + Sync {
    async fn serve(&self) {
        let read_task = self.south();
        let write_task = self.north();
        let _ = join!(read_task, write_task);
    }

    async fn south(&self);

    async fn north(&self);
}
